Index: /LMDZ5/branches/testing/libf/phylmd/fisrtilp.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/fisrtilp.F90	(revision 2541)
+++ /LMDZ5/branches/testing/libf/phylmd/fisrtilp.F90	(revision 2542)
@@ -21,4 +21,10 @@
   ! Objet: condensation et precipitation stratiforme.
   !        schema de nuage
+  ! Fusion de fisrt (physique sursaturation, P. LeVan K. Laval)
+  !             et ilp (il pleut, L. Li)
+  ! Principales parties:
+  ! P1> Evaporation de la precipitation (qui vient du niveau k+1)
+  ! P2> Formation du nuage (en k) 
+  ! P3> Formation de la precipitation (en k)
   !======================================================================
   !======================================================================
@@ -28,5 +34,5 @@
 
   !
-  ! Arguments:
+  ! Principaux inputs:
   !
   REAL dtime ! intervalle du temps (s)
@@ -35,4 +41,7 @@
   REAL t(klon,klev) ! temperature (K)
   REAL q(klon,klev) ! humidite specifique (kg/kg)
+  !
+  ! Principaux outputs:
+  !
   REAL d_t(klon,klev) ! incrementation de la temperature (K)
   REAL d_q(klon,klev) ! incrementation de la vapeur d'eau
@@ -46,4 +55,7 @@
   REAL prfl(klon,klev+1) ! flux d'eau precipitante aux interfaces (kg/m2/s)
   REAL psfl(klon,klev+1) ! flux d'eau precipitante aux interfaces (kg/m2/s) 
+  !
+  ! Autres arguments
+  ! 
   REAL ztv(klon,klev)
   REAL zqta(klon,klev),fraca(klon,klev) 
@@ -155,11 +167,10 @@
   !     Pour la conversion eau-neige
   REAL zlh_solid(klon), zm_solid
-  !IM 
-  !ym      INTEGER klevm1
   !---------------------------------------------------------------
   !
   ! Fonctions en ligne:
   !
-  REAL fallvs,fallvc ! vitesse de chute pour crystaux de glace
+  REAL fallvs,fallvc ! Vitesse de chute pour cristaux de glace
+                     ! (Heymsfield & Donner, 1990)
   REAL zzz
   include "YOETHF.h"
@@ -278,15 +289,14 @@
   zfrac_lessi = 0.
 
-  !AA----------------------------------------------------------
+  !AA==================================================================
   !
   ncoreczq=0
-  ! Boucle verticale (du haut vers le bas)
-  !
-  !IM : klevm1
-  !ym      klevm1=klev-1
+  ! BOUCLE VERTICALE (DU HAUT VERS LE BAS)
+  !
   DO k = klev, 1, -1
      !
-     !AA----------------------------------------------------------
-     !
+     !AA===============================================================
+     !
+     ! Initialisation temperature et vapeur
      DO i = 1, klon
         zt(i)=t(i,k)
@@ -312,14 +322,7 @@
         ENDDO
      ENDIF
-     !
-     !
-     ! Calculer l'evaporation de la precipitation
-     !
-
-
-     ! Calculer l'evaporation de la precipitation
-     !
-
-
+     ! ----------------------------------------------------------------
+     ! P1> Debut evaporation de la precipitation
+     ! ----------------------------------------------------------------
      IF (evap_prec) THEN
         DO i = 1, klon
@@ -328,4 +331,5 @@
            IF (zrfl(i)+zifl(i).GT.0.) THEN
 !>AJ
+              ! Calcul du qsat
               IF (thermcep) THEN
                  zdelta=MAX(0.,SIGN(1.,RTT-zt(i)))
@@ -350,22 +354,23 @@
            IF (zrfl(i)+zifl(i).GT.0.) THEN
 !>AJ
+                ! Evap max pour ne pas saturer la fraction sous le nuage
                 zqev = MAX (0.0, (zqs(i)-zq(i))*zneb(i) )
+                ! Calcul de l'evaporation du flux de precip herite
+                !   d'au-dessus
                 zqevt = coef_eva * (1.0-zq(i)/zqs(i)) * SQRT(zrfl(i)) &
                      * (paprs(i,k)-paprs(i,k+1))/pplay(i,k)*zt(i)*RD/RG
                 zqevt = MAX(0.0,MIN(zqevt,zrfl(i))) &
                      * RG*dtime/(paprs(i,k)-paprs(i,k+1))
+                ! Seuil pour ne pas saturer la fraction sous le nuage
                 zqev = MIN (zqev, zqevt)
+                ! Nouveau flux de precip
                 zrfln(i) = zrfl(i) - zqev*(paprs(i,k)-paprs(i,k+1)) &
                      /RG/dtime
-       
-                ! pour la glace, on ré-évapore toute la précip dans la
-                ! couche du dessous
-                ! la glace venant de la couche du dessus est simplement
-                ! dans la couche du dessous.
-       
+                ! Aucun flux liquide pour T < t_coup
                 IF (zt(i) .LT. t_coup.and.reevap_ice) zrfln(i)=0.
-       
+                ! Nouvelle vapeur 
                 zq(i) = zq(i) - (zrfln(i)-zrfl(i)) &
                      * (RG/(paprs(i,k)-paprs(i,k+1)))*dtime
+                ! Nouvelle temperature (chaleur latente)
                 zt(i) = zt(i) + (zrfln(i)-zrfl(i)) &
                      * (RG/(paprs(i,k)-paprs(i,k+1)))*dtime &
@@ -384,18 +389,19 @@
 !>AJ
      !JAM !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-     ! Modification de l'évaporation avec la glace
-     ! Différentiation entre précipitation liquide et solide 
-     ! On suppose que coef_evai=2*coef_eva
+     ! Modification de l'evaporation avec la glace
+     ! Differentiation entre precipitation liquide et solide 
      !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!  
      
+     ! Evap max pour ne pas saturer la fraction sous le nuage
          zqev0 = MAX (0.0, (zqs(i)-zq(i))*zneb(i) )
      !    zqev0 = MAX (0.0, zqs(i)-zq(i) ) 
 
      !JAM !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-     ! On différencie qsat pour l'eau et la glace
+     ! On differencie qsat pour l'eau et la glace
      ! Si zdelta=1. --> glace
      ! Si zdelta=0. --> eau liquide
      !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-         
+        
+         ! Calcul du qsat par rapport a l'eau liquide
          qsl= R2ES*FOEEW(zt(i),0.)/pplay(i,k)
          qsl= MIN(0.5,qsl)
@@ -403,4 +409,8 @@
          qsl= qsl*zcor
          
+         ! Calcul de l'evaporation du flux de precip herite
+         !   d'au-dessus
+         ! Formulation en racine du flux de precip
+         ! (Klemp & Wilhelmson, 1978; Sundqvist, 1988)
          zqevt = 1.*coef_eva*(1.0-zq(i)/qsl)*SQRT(zrfl(i)) &
               *(paprs(i,k)-paprs(i,k+1))/pplay(i,k)*zt(i)*RD/RG
@@ -408,4 +418,6 @@
               *RG*dtime/(paprs(i,k)-paprs(i,k+1)) 
 
+         
+         ! Calcul du qsat par rapport a la glace
          qsi= R2ES*FOEEW(zt(i),1.)/pplay(i,k)
          qsi= MIN(0.5,qsi)
@@ -413,4 +425,6 @@
          qsi= qsi*zcor
 
+         ! Calcul de la sublimation du flux de precip solide herite
+         !   d'au-dessus
          zqevti = 1.*coef_eva*(1.0-zq(i)/qsi)*SQRT(zifl(i)) &
               *(paprs(i,k)-paprs(i,k+1))/pplay(i,k)*zt(i)*RD/RG
@@ -420,5 +434,9 @@
               
      !JAM!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-     ! Vérification sur l'évaporation
+     ! Verification sur l'evaporation
+     ! On s'assure qu'on ne sature pas 
+     ! la fraction sous le nuage sinon on
+     ! repartit zqev0 en gardant la proportion
+     ! liquide / glace
      !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      
@@ -436,16 +454,11 @@
              ENDIF
          ENDIF
-     
+         ! Nouveaux flux de precip liquide et solide 
          zrfln(i) = Max(0.,zrfl(i) - zqev*(paprs(i,k)-paprs(i,k+1)) &
                                  /RG/dtime)
          zifln(i) = Max(0.,zifl(i) - zqevi*(paprs(i,k)-paprs(i,k+1)) &
                                  /RG/dtime)
-         
-     ! Pour la glace, on révapore toute la précip dans la couche du dessous
-     ! la glace venant de la couche du dessus est simplement dans la couche
-     ! du dessous.
-     
-     !    IF (zt(i) .LT. t_coup.and.reevap_ice) zrfln(i)=0.
-!         print*,zrfl(i),zrfln(i),zqevt,zqevti,RLMLT,'fluxdeprecip'
+
+         ! Mise a jour de la vapeur, temperature et flux de precip
          zq(i) = zq(i) - (zrfln(i)+zifln(i)-zrfl(i)-zifl(i)) &
                   * (RG/(paprs(i,k)-paprs(i,k+1)))*dtime
@@ -466,7 +479,9 @@
            zmelt = ((zt(i)-273.15)/(ztfondue-273.15))             ! jyg
            zmelt = MIN(MAX(zmelt,0.),1.)
+           ! Fusion de la glace
            zrfl(i)=zrfl(i)+zmelt*zifl(i)
            zifl(i)=zifl(i)*(1.-zmelt)
 !           print*,zt(i),'octavio1'
+           ! Chaleur latente de fusion
            zt(i)=zt(i)-zifl(i)*zmelt*(RG*dtime)/(paprs(i,k)-paprs(i,k+1)) &
                       *RLMLT/RCPD/(1.0+RVTMP2*zq(i))
@@ -481,4 +496,7 @@
       ENDIF ! (.NOT. ice_thermo) 
      
+     ! ----------------------------------------------------------------
+     ! Fin evaporation de la precipitation
+     ! ----------------------------------------------------------------
      ENDIF ! (evap_prec)
      !
@@ -518,4 +536,7 @@
 !       endif
 
+     ! ----------------------------------------------------------------
+     ! P2> Formation du nuage
+     ! ----------------------------------------------------------------
      IF (cpartiel) THEN
 
@@ -534,4 +555,5 @@
         if (iflag_pdf.eq.0) then
 
+           ! version creneau de (Li, 1998)
            do i=1,klon
               zdelq = min(ratqs(i,k),0.99) * zq(i)
@@ -575,5 +597,5 @@
            end if
 
-!CR: variation de qsat avec T en présence de glace ou non
+!CR: variation de qsat avec T en presence de glace ou non
 !initialisations
            do i=1,klon
@@ -587,4 +609,6 @@
 !Boucle iterative: ATTENTION, l'option -1 n'est plus activable ici
            if (iflag_fisrtilp_qsat.ge.0) then
+             ! Iteration pour condensation avec variation de qsat(T) 
+             ! -----------------------------------------------------
              do iter=1,iflag_fisrtilp_qsat+1
                 
@@ -599,8 +623,9 @@
                     if (iflag_t_glace.eq.0) then
                     zdelta = MAX(0.,SIGN(1.,t_glace_min_old-Tbef(i)))
-                    else if (iflag_t_glace.eq.1) then
+                    else if (iflag_t_glace.ge.1) then
                     zdelta = MAX(0.,SIGN(1.,t_glace_min-Tbef(i)))
                     endif
                  endif
+                 ! Calcul des PDF lognormales
                  zcvm5 = R5LES*RLVTT*(1.-zdelta) + R5IES*RLSTT*zdelta
                  zcvm5 = zcvm5 /RCPD/(1.0+RVTMP2*zq(i))
@@ -647,13 +672,6 @@
 
                  else
-
-!calcul de la fraction de glace
-!CR: on utilise la nouvelle fonction de JBM pour l ancien calcul
-!                 zfice(i) = icefrac_lsc(Tbef(i), t_glace_min, &
-!                                     t_glace_max, exposant_glace)
-!                 zfice(i) = 1.0 - (Tbef(i)-ztglace) / (RTT-ztglace)
-!                 zfice(i) = MIN(MAX(zfice(i),0.0),1.0)
-!                 zfice(i) = zfice(i)**nexpo
-                 if (iflag_t_glace.eq.1) then
+                 ! Iteration pour convergence avec qsat(T)
+                 if (iflag_t_glace.ge.1) then
                  CALL icefrac_lsc(klon,zt(:),pplay(:,k)/paprs(:,1),zfice(:))
                  endif
@@ -669,5 +687,5 @@
                  endif
                  
-                 if (iflag_t_glace.eq.1) then
+                 if (iflag_t_glace.ge.1) then
                  dzfice(i)= exposant_glace * zfice(i)**(exposant_glace-1) / (t_glace_min - t_glace_max)
                  endif
@@ -699,5 +717,7 @@
   
           
-             enddo
+             enddo ! iter=1,iflag_fisrtilp_qsat+1
+             ! Fin d'iteration pour condensation avec variation de qsat(T) 
+             ! -----------------------------------------------------------
            endif
 
@@ -707,5 +727,8 @@
 
 !        if (iflag_fisrtilp_qsat.eq.-1) then 
-!CR: ATTENTION option fausse mais a existe: pour la re-activer, prendre iflag_fisrtilp_qsat=0 et activer les lignes suivantes: 
+!------------------------------------------
+!CR: ATTENTION option fausse mais a existe:
+! pour la re-activer, prendre iflag_fisrtilp_qsat=0 et
+! activer les lignes suivantes: 
        IF (1.eq.0) THEN 
        DO i=1,klon
@@ -724,9 +747,14 @@
               rhcl(i,k)=(zqs(i)+zq(i)-zdelq)/2./zqs(i)
            ENDIF
-        ENDDO
-        ENDIF
+       ENDDO
+       ENDIF
+!------------------------------------------
 
 !        ELSE
 
+        ! Calcul de l'eau in-cloud (zqn),
+        ! moyenne dans la maille (zcond),
+        ! fraction nuageuse (rneb) et
+        ! humidite relative ciel-clair (rhcl)
         DO i=1,klon
            IF (rneb(i,k) .LE. 0.0) THEN
@@ -749,21 +777,6 @@
 !        ENDIF
 
-        !         do i=1,klon
-        !            IF (rneb(i,k) .LE. 0.0) zqn(i) = 0.0
-        !            IF (rneb(i,k) .GE. 1.0) zqn(i) = zq(i)
-        !            rneb(i,k) = MAX(0.0,MIN(1.0,rneb(i,k)))
-        !c           zcond(i) = MAX(0.0,zqn(i)-zqs(i))*rneb(i,k)/(1.+zdqs(i))
-        !c  On ne divise pas par 1+zdqs pour forcer a avoir l'eau predite par
-        !c  la convection.
-        !c  ATTENTION !!! Il va falloir verifier tout ca.
-        !            zcond(i) = MAX(0.0,zqn(i)-zqs(i))*rneb(i,k)
-        !c           print*,'ZDQS ',zdqs(i)
-        !c--Olivier
-        !            rhcl(i,k)=(zqs(i)+zq(i)-zdelq)/2./zqs(i)
-        !            IF (rneb(i,k) .LE. 0.0) rhcl(i,k)=zq(i)/zqs(i)
-        !            IF (rneb(i,k) .GE. 1.0) rhcl(i,k)=1.0
-        !c--fin
-        !           ENDDO
-     ELSE
+     ELSE ! de IF (cpartiel) 
+        ! Cas "tout ou rien"
         DO i = 1, klon
            IF (zq(i).GT.zqs(i)) THEN
@@ -775,5 +788,9 @@
         ENDDO
      ENDIF
-     !
+     ! ----------------------------------------------------------------
+     ! Fin de formation du nuage
+     ! ----------------------------------------------------------------
+     !
+     ! Mise a jour vapeur d'eau
      DO i = 1, klon
         zq(i) = zq(i) - zcond(i)
@@ -781,4 +798,6 @@
      ENDDO
 !AJ<
+     ! Chaleur latente apres formation nuage
+     ! -------------------------------------
      IF (.NOT. ice_thermo) THEN
         if (iflag_fisrtilp_qsat.lt.1) then
@@ -792,5 +811,5 @@
         endif
      ELSE
-         if (iflag_t_glace.eq.1) then
+         if (iflag_t_glace.ge.1) then
             CALL icefrac_lsc(klon,zt(:),pplay(:,k)/paprs(:,1),zfice(:))
          endif
@@ -825,7 +844,12 @@
        ENDIF
 !>AJ
+     ! ----------------------------------------------------------------
+     ! P3> Formation des precipitations
+     ! ----------------------------------------------------------------
      !
      ! Partager l'eau condensee en precipitation et eau liquide nuageuse
      !
+
+     ! Initialisation de zoliq (eau condensee moyenne dans la maille)
      DO i = 1, klon
         IF (rneb(i,k).GT.0.0) THEN
@@ -858,4 +882,11 @@
        ENDIF
      ENDIF
+
+     ! Calcul de radliq (eau condensee pour le rayonnement)
+     ! Iteration pour realiser une moyenne de l'eau nuageuse lors de la precip
+     ! Remarque: ce n'est donc pas l'eau restante en fin de precip mais une
+     ! eau moyenne restante dans le nuage sur la duree du pas de temps qui est
+     ! transmise au rayonnement;
+     ! ----------------------------------------------------------------
      DO i = 1, klon
         IF (rneb(i,k).GT.0.0) THEN
@@ -878,6 +909,6 @@
                  ztot = 0.0
               ELSE
-                 !  quantite d'eau a eliminer: zchau
-                 !  meme chose pour la glace: zfroi
+                 !  quantite d'eau a eliminer: zchau (Sundqvist, 1978)
+                 !  meme chose pour la glace: zfroi (Zender & Kiehl, 1997)
                  if (ptconv(i,k)) then
                     zcl   =cld_lc_con
@@ -916,4 +947,5 @@
         ENDDO  ! i = 1,klon
      ENDDO     ! n = 1,ninter
+     ! ----------------------------------------------------------------
      !
      IF (.NOT. ice_thermo) THEN
@@ -1028,5 +1060,5 @@
      ELSE
      ! JAM*************************************************
-     ! Revoir partie ci-dessous: à quoi servent psfl et prfl?
+     ! Revoir partie ci-dessous: a quoi servent psfl et prfl?
      ! *****************************************************
 
@@ -1040,4 +1072,7 @@
        ENDDO
      ENDIF
+     ! ----------------------------------------------------------------
+     ! Fin de formation des precipitations
+     ! ----------------------------------------------------------------
      !
      !
@@ -1110,9 +1145,9 @@
      ENDDO
      !
-     !AA----------------------------------------------------------
-     !                     FIN DE BOUCLE SUR K   
+     !AA===============================================================
+     !                     FIN DE LA BOUCLE VERTICALE  
   end DO
   !
-  !AA-----------------------------------------------------------
+  !AA==================================================================
   !
   ! Pluie ou neige au sol selon la temperature de la 1ere couche
Index: /LMDZ5/branches/testing/libf/phylmd/fonte_neige_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/fonte_neige_mod.F90	(revision 2541)
+++ /LMDZ5/branches/testing/libf/phylmd/fonte_neige_mod.F90	(revision 2542)
@@ -313,6 +313,5 @@
 !
   SUBROUTINE fonte_neige_get_vars(pctsrf, fqcalving_out, &
-       fqfonte_out, ffonte_out)
-
+       fqfonte_out, ffonte_out, run_off_lic_out)
 
 
@@ -330,4 +329,5 @@
     REAL, DIMENSION(klon), INTENT(OUT)      :: fqfonte_out
     REAL, DIMENSION(klon), INTENT(OUT)      :: ffonte_out
+    REAL, DIMENSION(klon), INTENT(OUT)      :: run_off_lic_out
 
     INTEGER   :: nisurf
@@ -343,4 +343,5 @@
        fqcalving_out(:) = fqcalving_out(:) + fqcalving_global(:,nisurf)*pctsrf(:,nisurf)
     ENDDO
+    run_off_lic_out(:)=run_off_lic(:)
 
   END SUBROUTINE fonte_neige_get_vars
@@ -349,5 +350,2 @@
 !
 END MODULE fonte_neige_mod
-
-
-
Index: /LMDZ5/branches/testing/libf/phylmd/icefrac_lsc_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/icefrac_lsc_mod.F90	(revision 2541)
+++ /LMDZ5/branches/testing/libf/phylmd/icefrac_lsc_mod.F90	(revision 2542)
@@ -14,6 +14,7 @@
   ! Doutriaux-Boucher & Quaas 2004, section 2.2.)
   !
-  ! (JBM 3/14 8/14)
+  ! (JBM 3/14 8/14 5/16)
   
+  USE print_control_mod, ONLY: lunout, prt_level
   INCLUDE "nuage.h"
 
@@ -33,5 +34,12 @@
 
   DO ip=1,np
-     www=(max(sig(ip)-sig0,0.))/(1.-sig0) ! w=1 at the surface and 0 for sig < sig0
+     IF (iflag_t_glace.EQ.1) THEN
+       ! Transition to ice close to surface for T<Tmax
+       ! w=1 at the surface and 0 for sig < sig0
+       www=(max(sig(ip)-sig0,0.))/(1.-sig0) 
+     ELSEIF (iflag_t_glace.GE.2) THEN
+       ! No convertion to ice close to surface
+       www = 0.
+     ENDIF
      tmin_tmp=www*t_glace_max+(1.-www)*t_glace_min
      icefrac_tmp= 1.0 - (temp(ip)-tmin_tmp) / (t_glace_max-tmin_tmp)
Index: /LMDZ5/branches/testing/libf/phylmd/iophy.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/iophy.F90	(revision 2541)
+++ /LMDZ5/branches/testing/libf/phylmd/iophy.F90	(revision 2542)
@@ -633,6 +633,11 @@
     ENDIF
 
-    ! Set swaero_diag=true if at least one of the concerned variables are defined 
-    IF (var%name=='topswad' .OR. var%name=='topswai' .OR. var%name=='solswad' .OR. var%name=='solswai' ) THEN
+    ! Set swaero_diag=true if at least one of the concerned variables are
+    ! defined
+    !--OB 30/05/2016 use wider set of variables
+    IF ( var%name=='topswad' .OR. var%name=='topswad0' .OR. var%name=='solswad' .OR. var%name=='solswad0' .OR. &
+         var%name=='topswai' .OR. var%name=='solswai'  .OR. ( iflag_rrtm==1 .AND. (                            &
+         var%name=='toplwad' .OR. var%name=='toplwad0' .OR. var%name=='sollwad' .OR. var%name=='sollwad0' .OR. &
+         var%name=='toplwai' .OR. var%name=='sollwai'  ) ) ) THEN
        IF  ( var%flag(iff)<=lev_files(iff) ) THEN
           swaero_diag=.TRUE.
Index: /LMDZ5/branches/testing/libf/phylmd/limit_slab.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/limit_slab.F90	(revision 2541)
+++ /LMDZ5/branches/testing/libf/phylmd/limit_slab.F90	(revision 2542)
@@ -42,7 +42,13 @@
   lmt_pas = NINT(86400./dtime)
   
+! Initialize saved variables
+     IF (.NOT. ALLOCATED(bils_save)) THEN
+        ALLOCATE(bils_save(klon), diff_sst_save(klon), diff_siv_save(klon), stat=ierr)
+        IF (ierr /= 0) CALL abort_physic('limit_slab', 'pb in allocation',1)
+     END IF
+
   ! F. Codron 5/14: add defaults for bils, diff_sst (0)
   IF (MOD(itime-1, lmt_pas) == 0) THEN   ! time to read
-     !$OMP MASTER  ! Only master thread
+!$OMP MASTER  ! Only master thread
      IF (is_mpi_root) THEN ! Only master processus
         print*,'in limit_slab time to read, itime=',itime
@@ -53,4 +59,5 @@
         ierr = NF90_OPEN ('limit_slab.nc', NF90_NOWRITE, nid)
         IF (ierr /= NF90_NOERR) THEN
+            PRINT *,'LIMIT_SLAB file not found'
             read_bils=.FALSE.
             read_sst=.FALSE.
@@ -112,5 +119,5 @@
         ierr = NF90_CLOSE(nid)
         IF (ierr /= NF90_NOERR) CALL abort_physic(modname,'Pb when closing file', 1)
-        END IF ! Read File
+        END IF ! Read File 
         IF (read_sst) THEN
 ! Calculate difference in temperature between this day and one ahead
@@ -128,11 +135,12 @@
 
 !$OMP END MASTER
+!$OMP BARRIER
        
-     IF (.NOT. ALLOCATED(bils_save)) THEN
-        ALLOCATE(bils_save(klon), diff_sst_save(klon), diff_siv_save(klon), stat=ierr)
-        IF (ierr /= 0) CALL abort_physic('limit_slab', 'pb in allocation',1)
-     END IF
-
+! Send fields to all processes
 ! Give default values if needed
+     CALL bcast(read_bils)
+     CALL bcast(read_sst)
+     CALL bcast(read_siv)
+     PRINT *,'limit_slab sst',read_sst,'siv',read_siv,'qflux',read_bils
      IF (read_bils) THEN
          CALL Scatter(bils_glo, bils_save)
@@ -156,5 +164,8 @@
   diff_sst(:) = diff_sst_save(:)
   diff_siv(:) = diff_siv_save(:)
+! For Debug purpose
+!  PRINT *,'limit_slab sst',MINVAL(diff_sst(:)),MAXVAL(diff_sst(:))
+!  PRINT *,'limit_slab siv',MINVAL(diff_siv(:)),MAXVAL(diff_siv(:))
+!  PRINT *,'limit_slab bils',MINVAL(lmt_bils(:)),MAXVAL(lmt_bils(:))
 
-  
 END SUBROUTINE limit_slab
Index: /LMDZ5/branches/testing/libf/phylmd/oasis.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/oasis.F90	(revision 2541)
+++ /LMDZ5/branches/testing/libf/phylmd/oasis.F90	(revision 2542)
@@ -55,5 +55,9 @@
   INTEGER, PARAMETER :: ids_atmco2 = 24
   INTEGER, PARAMETER :: ids_taumod = 25
-  INTEGER, PARAMETER :: maxsend    = 25  ! Maximum number of fields to send
+  INTEGER, PARAMETER :: ids_qraioc = 26
+  INTEGER, PARAMETER :: ids_qsnooc = 27
+  INTEGER, PARAMETER :: ids_qraiic = 28
+  INTEGER, PARAMETER :: ids_qsnoic = 29
+  INTEGER, PARAMETER :: maxsend    = 29  ! Maximum number of fields to send
   
   ! Id for fields received from ocean
@@ -177,4 +181,8 @@
             infosend(ids_atmco2)%action = .TRUE. ; infosend(ids_atmco2)%name = 'COATMCO2'
         ENDIF
+        infosend(ids_qraioc)%action = .TRUE. ; infosend(ids_qraioc)%name = 'COQRAIOC'
+        infosend(ids_qsnooc)%action = .TRUE. ; infosend(ids_qsnooc)%name = 'COQSNOOC'
+        infosend(ids_qraiic)%action = .TRUE. ; infosend(ids_qraiic)%name = 'COQRAIIC'
+        infosend(ids_qsnoic)%action = .TRUE. ; infosend(ids_qsnoic)%name = 'COQSNOIC'
         
     ELSE IF (version_ocean=='opa8') THEN
Index: /LMDZ5/branches/testing/libf/phylmd/ocean_cpl_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/ocean_cpl_mod.F90	(revision 2541)
+++ /LMDZ5/branches/testing/libf/phylmd/ocean_cpl_mod.F90	(revision 2542)
@@ -1,2 +1,4 @@
+!
+! $Id$
 !
 MODULE ocean_cpl_mod
@@ -10,4 +12,5 @@
 
   PUBLIC :: ocean_cpl_init, ocean_cpl_noice, ocean_cpl_ice
+
 
 !****************************************************************************************
@@ -63,4 +66,6 @@
     USE calcul_fluxs_mod
     USE indice_sol_mod
+    USE phys_output_var_mod, ONLY : sens_prec_liq_o, sens_prec_sol_o, lat_prec_liq_o, lat_prec_sol_o
+    USE cpl_mod,             ONLY : gath2cpl
 
     INCLUDE "YOMCST.h"
@@ -99,8 +104,9 @@
     REAL, DIMENSION(klon), INTENT(OUT)       :: tsurf_new
     REAL, DIMENSION(klon), INTENT(OUT)       :: dflux_s, dflux_l      
+  
 
 ! Local variables
 !****************************************************************************************
-    INTEGER               :: i
+    INTEGER               :: i, j
     INTEGER, DIMENSION(1) :: iloc
     REAL, DIMENSION(klon) :: cal, beta, dif_grnd
@@ -110,4 +116,6 @@
     REAL, DIMENSION(klon) :: u1_lay, v1_lay
     LOGICAL               :: check=.FALSE.
+    REAL, DIMENSION(klon) :: sens_prec_liq, sens_prec_sol    
+    REAL, DIMENSION(klon) :: lat_prec_liq, lat_prec_sol    
 
 ! End definitions
@@ -130,4 +138,6 @@
     dif_grnd = 0.
     agesno(:) = 0.
+    sens_prec_liq = 0.; sens_prec_sol = 0.; lat_prec_liq = 0.; lat_prec_sol = 0.
+    
 
     DO i = 1, knon
@@ -141,5 +151,15 @@
          radsol, dif_grnd, temp_air, spechum, u1_lay, v1_lay, gustiness, &
          f_qsat_oce,AcoefH, AcoefQ, BcoefH, BcoefQ, &
-         tsurf_new, evap, fluxlat, fluxsens, dflux_s, dflux_l)
+         tsurf_new, evap, fluxlat, fluxsens, dflux_s, dflux_l, &
+         sens_prec_liq, sens_prec_sol, lat_prec_liq, lat_prec_sol)
+    do j = 1, knon
+      i = knindex(j)
+      sens_prec_liq_o(i,1) = sens_prec_liq(j)
+      sens_prec_sol_o(i,1) = sens_prec_sol(j)
+      lat_prec_liq_o(i,1) = lat_prec_liq(j)
+      lat_prec_sol_o(i,1) = lat_prec_sol(j)
+    enddo
+
+
     
 ! - Flux calculation at first modele level for U and V
@@ -171,5 +191,6 @@
     CALL cpl_send_ocean_fields(itime, knon, knindex, &
          swnet, lwnet, fluxlat, fluxsens, &
-         precip_rain, precip_snow, evap, tsurf_new, fder_new, alb1, flux_u1, flux_v1, windsp)
+         precip_rain, precip_snow, evap, tsurf_new, fder_new, alb1, flux_u1, flux_v1, windsp,&
+         sens_prec_liq, sens_prec_sol, lat_prec_liq, lat_prec_sol)
     
 
@@ -199,4 +220,5 @@
     USE calcul_fluxs_mod
     USE indice_sol_mod
+    USE phys_output_var_mod, ONLY : sens_prec_liq_o, sens_prec_sol_o, lat_prec_liq_o, lat_prec_sol_o
 
     INCLUDE "YOMCST.h"
@@ -237,8 +259,9 @@
     REAL, DIMENSION(klon), INTENT(OUT)       :: tsurf_new
     REAL, DIMENSION(klon), INTENT(OUT)       :: dflux_s, dflux_l      
+  
 
 ! Local variables
 !****************************************************************************************
-    INTEGER                 :: i
+    INTEGER                 :: i, j
     INTEGER, DIMENSION(1)   :: iloc
     LOGICAL                 :: check=.FALSE.
@@ -249,4 +272,6 @@
     REAL, DIMENSION(klon)   :: u0, v0
     REAL, DIMENSION(klon)   :: u1_lay, v1_lay
+    REAL, DIMENSION(klon) :: sens_prec_liq, sens_prec_sol    
+    REAL, DIMENSION(klon) :: lat_prec_liq, lat_prec_sol    
 
 ! End definitions
@@ -254,4 +279,6 @@
     
     IF (check) WRITE(*,*)'Entering surface_seaice, knon=',knon 
+
+    sens_prec_liq = 0.; sens_prec_sol = 0.; lat_prec_liq = 0.; lat_prec_sol = 0.
 
 !****************************************************************************************
@@ -285,5 +312,13 @@
          radsol, dif_grnd, temp_air, spechum, u1_lay, v1_lay, gustiness, &
          f_qsat_oce,AcoefH, AcoefQ, BcoefH, BcoefQ, &
-         tsurf_new, evap, fluxlat, fluxsens, dflux_s, dflux_l)
+         tsurf_new, evap, fluxlat, fluxsens, dflux_s, dflux_l, &
+         sens_prec_liq, sens_prec_sol, lat_prec_liq, lat_prec_sol)
+    do j = 1, knon
+      i = knindex(j)
+      sens_prec_liq_o(i,2) = sens_prec_liq(j)
+      sens_prec_sol_o(i,2) = sens_prec_sol(j)
+      lat_prec_liq_o(i,2) = lat_prec_liq(j)
+      lat_prec_sol_o(i,2) = lat_prec_sol(j)
+    enddo
 
 
@@ -317,5 +352,7 @@
        pctsrf, lafin, rlon, rlat, &
        swnet, lwnet, fluxlat, fluxsens, &
-       precip_rain, precip_snow, evap, tsurf_new, fder_new, alb1, flux_u1, flux_v1)
+       precip_rain, precip_snow, evap, tsurf_new, fder_new, alb1, flux_u1, flux_v1,&
+       sens_prec_liq, sens_prec_sol, lat_prec_liq, lat_prec_sol)
+
  
 
Index: /LMDZ5/branches/testing/libf/phylmd/ocean_forced_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/ocean_forced_mod.F90	(revision 2541)
+++ /LMDZ5/branches/testing/libf/phylmd/ocean_forced_mod.F90	(revision 2542)
@@ -1,2 +1,4 @@
+!
+! $Id$
 !
 MODULE ocean_forced_mod
@@ -32,4 +34,6 @@
     USE mod_grid_phy_lmdz
     USE indice_sol_mod
+    USE phys_output_var_mod, ONLY : sens_prec_liq_o, sens_prec_sol_o, lat_prec_liq_o, lat_prec_sol_o
+
     INCLUDE "YOMCST.h"
     INCLUDE "clesphys.h"
@@ -66,5 +70,5 @@
 ! Local variables
 !****************************************************************************************
-    INTEGER                     :: i
+    INTEGER                     :: i, j
     REAL, DIMENSION(klon)       :: cal, beta, dif_grnd
     REAL, DIMENSION(klon)       :: alb_neig, tsurf_lim, zx_sl
@@ -72,4 +76,6 @@
     REAL, DIMENSION(klon)       :: u1_lay, v1_lay
     LOGICAL                     :: check=.FALSE.
+    REAL, DIMENSION(klon) :: sens_prec_liq, sens_prec_sol    
+    REAL, DIMENSION(klon) :: lat_prec_liq, lat_prec_sol    
 
 !****************************************************************************************
@@ -103,4 +109,6 @@
     alb_neig(:) = 0.
     agesno(:) = 0.
+    sens_prec_liq = 0.; sens_prec_sol = 0.; lat_prec_liq = 0.; lat_prec_sol = 0.
+
 ! Suppose zero surface speed
     u0(:)=0.0
@@ -115,5 +123,15 @@
          radsol, dif_grnd, temp_air, spechum, u1_lay, v1_lay, gustiness, &
          f_qsat_oce,AcoefH, AcoefQ, BcoefH, BcoefQ, &
-         tsurf_new, evap, fluxlat, fluxsens, dflux_s, dflux_l)
+         tsurf_new, evap, fluxlat, fluxsens, dflux_s, dflux_l, &
+         sens_prec_liq, sens_prec_sol, lat_prec_liq, lat_prec_sol)
+
+    do j = 1, knon
+      i = knindex(j)
+      sens_prec_liq_o(i,1) = sens_prec_liq(j)
+      sens_prec_sol_o(i,1) = sens_prec_sol(j)
+      lat_prec_liq_o(i,1) = lat_prec_liq(j)
+      lat_prec_sol_o(i,1) = lat_prec_sol(j)
+    enddo
+
 
 ! - Flux calculation at first modele level for U and V
@@ -148,4 +166,5 @@
     USE fonte_neige_mod,  ONLY : fonte_neige
     USE indice_sol_mod
+    USE phys_output_var_mod, ONLY : sens_prec_liq_o, sens_prec_sol_o, lat_prec_liq_o, lat_prec_sol_o
 
 !    INCLUDE "indicesol.h"
@@ -189,5 +208,5 @@
 !****************************************************************************************
     LOGICAL                     :: check=.FALSE.
-    INTEGER                     :: i
+    INTEGER                     :: i, j
     REAL                        :: zfra
     REAL, PARAMETER             :: t_grnd=271.35
@@ -197,4 +216,7 @@
     REAL, DIMENSION(klon)       :: u0, v0
     REAL, DIMENSION(klon)       :: u1_lay, v1_lay
+    REAL, DIMENSION(klon)       :: sens_prec_liq, sens_prec_sol    
+    REAL, DIMENSION(klon)       :: lat_prec_liq, lat_prec_sol    
+
 
 !****************************************************************************************
@@ -208,4 +230,5 @@
 !                    dflux_s, dflux_l and qsurf
 !****************************************************************************************
+
     tsurf_tmp(:) = tsurf_in(:)
 
@@ -227,4 +250,6 @@
 
     beta = 1.0
+    sens_prec_liq = 0.; sens_prec_sol = 0.; lat_prec_liq = 0.; lat_prec_sol = 0.
+
 ! Suppose zero surface speed
     u0(:)=0.0
@@ -237,5 +262,13 @@
          radsol, dif_grnd, temp_air, spechum, u1_lay, v1_lay, gustiness, &
          f_qsat_oce,AcoefH, AcoefQ, BcoefH, BcoefQ, &
-         tsurf_new, evap, fluxlat, fluxsens, dflux_s, dflux_l)
+         tsurf_new, evap, fluxlat, fluxsens, dflux_s, dflux_l, &
+         sens_prec_liq, sens_prec_sol, lat_prec_liq, lat_prec_sol)
+    do j = 1, knon
+      i = knindex(j)
+      sens_prec_liq_o(i,2) = sens_prec_liq(j)
+      sens_prec_sol_o(i,2) = sens_prec_sol(j)
+      lat_prec_liq_o(i,2) = lat_prec_liq(j)
+      lat_prec_sol_o(i,2) = lat_prec_sol(j)
+    enddo
 
 ! - Flux calculation at first modele level for U and V
